(* Q1 *)
let rec puissance a b = 
	if b = 0 then 1
	else a * puissance a (b-1)

(* Q2 *)
let rec reste a b =
	if a < b then a
	else reste (a - b) b

(* Q3 *)
let rec pgcd a b =
		 if b = 0 then a
	else pgcd b (reste a b)


(* Q4 *)
let rec puiss_rapide a b =
	if b = 0 then 
		1
	else if b mod 2 = 1 then 
		a * puiss_rapide (a*a) (b/2) 
	else 
		puiss_rapide (a*a) (b/2) 


(* Q5 *)
let rec div_eucl x y =
	if x < y then (0, x)
	else let (q, r) = div_eucl (x - y) y in
		 q + 1, r ;;

(* Q6 *)
let rec decomp b x =
	if x < b then (
		print_int x;
		print_newline () 
	) else (
		let q, r = x / b, x mod b in
		decomp b q;
		print_int r;
		print_newline ();
	)

(* Q7 *)
(* On va utiliser une fonction auxiliaire qui va tester
   tous les entiers relatifs, dans l'ordre suivant:
   0, 1, -1, 2, -2, 3, -3, ... n, -n, n+1, ... 
   J'ai modifié un peu la fonction par rapport à ce
   qui est demandé dans l'énoncé: la fonction ci-dessous
   affiche la première racine trouvée *)
let a_racine f = 
	(* renvoie true si f a une racine a partir de x dans l'ordre ci-dessus *)
	let rec a_racine_a_partir_de x =
		if f x = 0 then (print_int x; print_newline (); true) else 
		if x = 0 then 
			a_racine_a_partir_de 1
		else if x > 0 then 
			a_racine_a_partir_de (-x)
		else
			a_racine_a_partir_de (-x + 1) (* x est négatif donc -x + 1 = |x| + 1 *)
	in
	a_racine_a_partir_de 0

(* test () exécute tous les tests *)
let test () = 
	assert (puissance 5 3 = 125);
	assert (puiss_rapide 5 3 = 125);
	assert (reste 65321 986 = 65321 mod 986);

	assert (pgcd 51 124 = 1);
	assert (pgcd (3*7*11*4) (3*13*4*2) = 3*4);

	assert (div_eucl 956478 1251 = (956478 / 1251, 956478 mod 1251));

	decomp 2 18; (* affiche 1 0 0 1 0 *)
	decomp 10 1951; (* affiche 1951 *)

	assert (a_racine (fun x -> x + 152))
;;

test() ;;

